From d30e5513440dad1b100927ad746035ffe6320dd8 Mon Sep 17 00:00:00 2001
From: Takuya Nishimoto <nishimotz@gmail.com>
Date: Fri, 13 Jun 2014 19:10:27 +0900
Subject: [PATCH] use column/row headers for braille display

---
 source/braille.py | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

diff --git a/source/braille.py b/source/braille.py
index 6971d81..31ccef4 100644
--- a/source/braille.py
+++ b/source/braille.py
@@ -492,15 +492,18 @@ def getBrailleTextForProperties(**propertyValues):
 			# Translators: Displayed in braille when an object (e.g. a tree view item) has a hierarchical level.
 			# %s is replaced with the level.
 			textList.append(_('lv %s')%positionInfo['level'])
+	rowHeaderText = propertyValues.get("rowHeaderText")
+	if rowHeaderText:
+		textList.append(rowHeaderText)
+	columnHeaderText = propertyValues.get("columnHeaderText")
+	if columnHeaderText:
+		textList.append(columnHeaderText)
 	if rowNumber:
 		if includeTableCellCoords and not cellCoordsText: 
 			# Translators: Displayed in braille for a table cell row number.
 			# %s is replaced with the row number.
 			textList.append(_("r%s") % rowNumber)
 	if columnNumber:
-		columnHeaderText = propertyValues.get("columnHeaderText")
-		if columnHeaderText:
-			textList.append(columnHeaderText)
 		if includeTableCellCoords and not cellCoordsText:
 			# Translators: Displayed in braille for a table cell column number.
 			# %s is replaced with the column number.
@@ -536,6 +539,8 @@ class NVDAObjectRegion(Region):
 			keyboardShortcut=obj.keyboardShortcut if presConfig["reportKeyboardShortcuts"] else None,
 			positionInfo=obj.positionInfo if presConfig["reportObjectPositionInformation"] else None,
 			cellCoordsText=obj.cellCoordsText if config.conf["documentFormatting"]["reportTableCellCoords"] else None,
+			columnHeaderText=obj.columnHeaderText if hasattr(obj, "columnHeaderText") and config.conf["documentFormatting"]["reportTableHeaders"] else None,
+			rowHeaderText=obj.rowHeaderText if hasattr(obj, "rowHeaderText") and config.conf["documentFormatting"]["reportTableHeaders"] else None,
 		)
 		self.rawText = text + self.appendText
 		super(NVDAObjectRegion, self).update()
@@ -580,6 +585,7 @@ def getControlFieldBraille(field, ancestors, reportStart, formatConfig):
 		}
 		if reportTableHeaders:
 			props["columnHeaderText"] = field.get("table-columnheadertext")
+			props["rowHeaderText"] = fields.get("table-rowheadertext")
 		return getBrailleTextForProperties(**props)
 
 	elif reportStart:
-- 
1.9.2.msysgit.0

